%Longin Jan Latecki, latecki@temple.edu, Nov. 20, 2002
%Based on the code written by Roland Opfer, my student at Univ. of Hamburg 
%Function evo3 returns a simplified polyline that has 'pointsleft' vertices

function b = evo3(A, pointsleft); %Function returns a simplified polyline that has 'pointsleft' vertices

%run example: afrika; b = evo3(A, 20);
%input: A is a matrix with line segments of the polyline, with each row:
%x-coord of the begining point, y-coord of the begining point, x-coord of the end point, y-coord of the end point,
%'pointsleft' number of vertices of the output polyline
%output: sequence of vertices of the output polyline, with each row:
%x-coord of a vertex, y-coord of a vertex
%the firest and last polyline points are never removed


Z=A(:,1)+i*A(:,2);

X=real(Z);
Y=imag(Z);

X1=real(Z);    
Y1=imag(Z);

n=length(X1);


Zneu=Z;
for i1=1:n-pointsleft
Winkelmaass=Winkel(Zneu);%Function: computes a relvance measure for every point"
[y,I]=sort(Winkelmaass);
Zneu(I(1))=[];
%in Zneu the points with the smallest relevance measure is removed
end

figure; 
xmax=max(X)+0.1*max(X);
xmin=min(X)-0.1*min(X);
ymax=max(Y)+0.1*max(Y);
ymin=min(Y)-0.1*min(Y); %Size of Axis
axis([xmin xmax ymin ymax])
hold on;
plot(X1,Y1);%erster Plot
axis([xmin xmax ymin ymax])
     hold on;
     plot(real(Zneu), imag(Zneu),'r');
     title(['Original Points: ', num2str(n),'   Evolved Points: ', num2str(pointsleft)])

hold off;


b=[real(Zneu) imag(Zneu)];
return

